Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -266,11 +266,9 @@
     }
 
-    private bool startPending;
     public void Start() {
       if ((ExecutionState != ExecutionState.Prepared) && (ExecutionState != ExecutionState.Paused))
         throw new InvalidOperationException(string.Format("Start not allowed in execution state \"{0}\".", ExecutionState));
 
-      if (Algorithm != null && !startPending) {
-        startPending = true;
+      if (Algorithm != null) {
         //create cloned algorithms
         if (clonedAlgorithms.Count == 0) {
@@ -335,5 +333,5 @@
       if (!pausePending) {
         pausePending = true;
-        if (!startPending) PauseAllClonedAlgorithms();
+        PauseAllClonedAlgorithms();
       }
     }
@@ -352,5 +350,5 @@
       if (!stopPending) {
         stopPending = true;
-        if (!startPending) StopAllClonedAlgorithms();
+        StopAllClonedAlgorithms();
       }
     }
@@ -389,5 +387,4 @@
 
     private void AggregateResultValues(IDictionary<string, IItem> results) {
-      Dictionary<string, List<double>> resultValues = new Dictionary<string, List<double>>();
       IEnumerable<IRun> runs = clonedAlgorithms.Select(alg => alg.Runs.FirstOrDefault()).Where(run => run != null);
       IEnumerable<KeyValuePair<string, IItem>> resultCollections = runs.Where(x => x != null).SelectMany(x => x.Results).ToList();
@@ -552,6 +549,6 @@
       }
       if (problem != null) problem.Reset -= new EventHandler(Problem_Reset);
-      if (Problem != null) Problem.Reset += new EventHandler(Problem_Reset);
       problem = (IDataAnalysisProblem)algorithm.Problem;
+      if (problem != null) problem.Reset += new EventHandler(Problem_Reset);
       OnProblemChanged();
     }
@@ -653,19 +650,10 @@
 
     private readonly object locker = new object();
+    private readonly object resultLocker = new object();
     private void ClonedAlgorithm_Started(object sender, EventArgs e) {
-      lock (locker) {
-        IAlgorithm algorithm = sender as IAlgorithm;
+      IAlgorithm algorithm = sender as IAlgorithm;
+      lock (resultLocker) {
         if (algorithm != null && !results.ContainsKey(algorithm.Name))
           results.Add(new Result(algorithm.Name, "Contains results for the specific fold.", algorithm.Results));
-
-        if (startPending) {
-          int startedAlgorithms = clonedAlgorithms.Count(alg => alg.ExecutionState == ExecutionState.Started);
-          if (startedAlgorithms == NumberOfWorkers.Value ||
-             clonedAlgorithms.All(alg => alg.ExecutionState != ExecutionState.Prepared))
-            startPending = false;
-
-          if (pausePending) PauseAllClonedAlgorithms();
-          if (stopPending) StopAllClonedAlgorithms();
-        }
       }
     }
@@ -718,5 +706,4 @@
     public event EventHandler Started;
     private void OnStarted() {
-      startPending = false;
       ExecutionState = ExecutionState.Started;
       EventHandler handler = Started;
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceConst.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceConst.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceConst.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -36,5 +37,7 @@
       get { return (IValueParameter<DoubleValue>)Parameters["Scale"]; }
     }
-
+    private bool HasFixedScaleParameter {
+      get { return ScaleParameter.Value != null; }
+    }
     [StorableConstructor]
     private CovarianceConst(bool deserializing)
@@ -59,5 +62,5 @@
 
     public int GetNumberOfParameters(int numberOfVariables) {
-      return ScaleParameter.Value != null ? 0 : 1;
+      return HasFixedScaleParameter ? 0 : 1;
     }
 
@@ -71,5 +74,5 @@
       int c = 0;
       // gather parameter values
-      if (ScaleParameter.Value != null) {
+      if (HasFixedScaleParameter) {
         scale = ScaleParameter.Value.Value;
       } else {
@@ -87,5 +90,9 @@
       cov.Covariance = (x, i, j) => scale;
       cov.CrossCovariance = (x, xt, i, j) => scale;
-      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, scale, columnIndices);
+      if (HasFixedScaleParameter) {
+        cov.CovarianceGradient = (x, i, j) => Enumerable.Empty<double>();
+      } else {
+        cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, scale, columnIndices);
+      }
       return cov;
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinear.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinear.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinear.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinearArd.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinearArd.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceLinearArd.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -37,4 +37,7 @@
       get { return (IValueParameter<DoubleArray>)Parameters["InverseLength"]; }
     }
+    private bool HasFixedInverseLengthParameter {
+      get { return InverseLengthParameter.Value != null; }
+    }
 
     [StorableConstructor]
@@ -57,8 +60,8 @@
 
     public int GetNumberOfParameters(int numberOfVariables) {
-      if (InverseLengthParameter.Value == null)
+      if (HasFixedInverseLengthParameter)
+        return 0;
+      else
         return numberOfVariables;
-      else
-        return 0;
     }
 
@@ -71,5 +74,5 @@
     private void GetParameterValues(double[] p, out double[] inverseLength) {
       // gather parameter values
-      if (InverseLengthParameter.Value != null) {
+      if (HasFixedInverseLengthParameter) {
         inverseLength = InverseLengthParameter.Value.ToArray();
       } else {
@@ -81,9 +84,13 @@
       double[] inverseLength;
       GetParameterValues(p, out inverseLength);
+      var fixedInverseLength = HasFixedInverseLengthParameter;
       // create functions
       var cov = new ParameterizedCovarianceFunction();
       cov.Covariance = (x, i, j) => Util.ScalarProd(x, i, j, inverseLength, columnIndices);
       cov.CrossCovariance = (x, xt, i, j) => Util.ScalarProd(x, i, xt, j, inverseLength, columnIndices);
-      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, inverseLength, columnIndices);
+      if (fixedInverseLength)
+        cov.CovarianceGradient = (x, i, j) => Enumerable.Empty<double>();
+      else
+        cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, inverseLength, columnIndices);
       return cov;
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMask.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMaternIso.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMaternIso.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceMaternIso.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -45,5 +45,10 @@
       get { return (IConstrainedValueParameter<IntValue>)Parameters["D"]; }
     }
-
+    private bool HasFixedScaleParameter {
+      get { return ScaleParameter.Value != null; }
+    }
+    private bool HasFixedInverseLengthParameter {
+      get { return InverseLengthParameter.Value != null; }
+    }
 
     [StorableConstructor]
@@ -76,6 +81,6 @@
     public int GetNumberOfParameters(int numberOfVariables) {
       return
-        (InverseLengthParameter.Value != null ? 0 : 1) +
-        (ScaleParameter.Value != null ? 0 : 1);
+        (HasFixedInverseLengthParameter ? 0 : 1) +
+        (HasFixedScaleParameter ? 0 : 1);
     }
 
@@ -90,5 +95,5 @@
       // gather parameter values
       int c = 0;
-      if (InverseLengthParameter.Value != null) {
+      if (HasFixedInverseLengthParameter) {
         inverseLength = InverseLengthParameter.Value.Value;
       } else {
@@ -97,5 +102,5 @@
       }
 
-      if (ScaleParameter.Value != null) {
+      if (HasFixedScaleParameter) {
         scale = ScaleParameter.Value.Value;
       } else {
@@ -110,4 +115,6 @@
       int d = DParameter.Value.Value;
       GetParameterValues(p, out scale, out inverseLength);
+      var fixedInverseLength = HasFixedInverseLengthParameter;
+      var fixedScale = HasFixedScaleParameter;
       // create functions
       var cov = new ParameterizedCovarianceFunction();
@@ -122,5 +129,5 @@
         return scale * m(d, dist);
       };
-      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, d, scale, inverseLength, columnIndices);
+      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, d, scale, inverseLength, columnIndices, fixedInverseLength, fixedScale);
       return cov;
     }
@@ -149,11 +156,12 @@
 
 
-    private static IEnumerable<double> GetGradient(double[,] x, int i, int j, int d, double scale, double inverseLength, IEnumerable<int> columnIndices) {
+    private static IEnumerable<double> GetGradient(double[,] x, int i, int j, int d, double scale, double inverseLength, IEnumerable<int> columnIndices,
+      bool fixedInverseLength, bool fixedScale) {
       double dist = i == j
                    ? 0.0
                    : Math.Sqrt(Util.SqrDist(x, i, j, Math.Sqrt(d) * inverseLength, columnIndices));
 
-      yield return scale * dm(d, dist);
-      yield return 2 * scale * m(d, dist);
+      if (!fixedInverseLength) yield return scale * dm(d, dist);
+      if (!fixedScale) yield return 2 * scale * m(d, dist);
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNeuralNetwork.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNeuralNetwork.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNeuralNetwork.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -22,7 +22,4 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;
-using System.Linq.Expressions;
-using AutoDiff;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -42,4 +39,10 @@
     public IValueParameter<DoubleValue> LengthParameter {
       get { return (IValueParameter<DoubleValue>)Parameters["Length"]; }
+    }
+    private bool HasFixedScaleParameter {
+      get { return ScaleParameter.Value != null; }
+    }
+    private bool HasFixedLengthParameter {
+      get { return LengthParameter.Value != null; }
     }
 
@@ -68,6 +71,6 @@
     public int GetNumberOfParameters(int numberOfVariables) {
       return
-        (ScaleParameter.Value != null ? 0 : 1) +
-        (LengthParameter.Value != null ? 0 : 1);
+        (HasFixedScaleParameter ? 0 : 1) +
+        (HasFixedLengthParameter ? 0 : 1);
     }
 
@@ -83,5 +86,5 @@
       // gather parameter values
       int c = 0;
-      if (LengthParameter.Value != null) {
+      if (HasFixedLengthParameter) {
         length = LengthParameter.Value.Value;
       } else {
@@ -90,5 +93,5 @@
       }
 
-      if (ScaleParameter.Value != null) {
+      if (HasFixedScaleParameter) {
         scale = ScaleParameter.Value.Value;
       } else {
@@ -99,83 +102,61 @@
     }
 
-
-    private static Func<Term, UnaryFunc> asin = UnaryFunc.Factory(
-        x => Math.Asin(x),      // evaluate
-        x => 1 / Math.Sqrt(1 - x * x));  // derivative of atan
-    private static Func<Term, UnaryFunc> sqrt = UnaryFunc.Factory(
-      x => Math.Sqrt(x),
-      x => 1 / (2 * Math.Sqrt(x)));
-
     public ParameterizedCovarianceFunction GetParameterizedCovarianceFunction(double[] p, IEnumerable<int> columnIndices) {
       double length, scale;
       GetParameterValues(p, out scale, out length);
-      // create functions
-      AutoDiff.Variable p0 = new AutoDiff.Variable();
-      AutoDiff.Variable p1 = new AutoDiff.Variable();
-      var l = TermBuilder.Exp(2.0 * p0);
-      var s = TermBuilder.Exp(2.0 * p1);
-      AutoDiff.Variable[] x1 = new AutoDiff.Variable[columnIndices.Count()];
-      AutoDiff.Variable[] x2 = new AutoDiff.Variable[columnIndices.Count()];
-      AutoDiff.Term sx = 1;
-      AutoDiff.Term s1 = 1;
-      AutoDiff.Term s2 = 1;
-      foreach (var k in columnIndices) {
-        x1[k] = new AutoDiff.Variable();
-        x2[k] = new AutoDiff.Variable();
-        sx += x1[k] * x2[k];
-        s1 += x1[k] * x1[k];
-        s2 += x2[k] * x2[k];
-      }
-
-      var parameter = x1.Concat(x2).Concat(new AutoDiff.Variable[] { p0, p1 }).ToArray();
-      var values = new double[x1.Length + x2.Length + 2];
-      var c = (s * asin(sx / (sqrt((l + s1) * (l + s2))))).Compile(parameter);
+      var fixedLength = HasFixedLengthParameter;
+      var fixedScale = HasFixedScaleParameter;
 
       var cov = new ParameterizedCovarianceFunction();
       cov.Covariance = (x, i, j) => {
-        int k = 0;
+        double sx = 1.0;
+        double s1 = 1.0;
+        double s2 = 1.0;
         foreach (var col in columnIndices) {
-          values[k] = x[i, col];
-          k++;
+          sx += x[i, col] * x[j, col];
+          s1 += x[i, col] * x[i, col];
+          s2 += x[j, col] * x[j, col];
         }
-        foreach (var col in columnIndices) {
-          values[k] = x[j, col];
-          k++;
-        }
-        values[k] = Math.Log(Math.Sqrt(length));
-        values[k + 1] = Math.Log(Math.Sqrt(scale));
-        return c.Evaluate(values);
+
+        return (scale * Math.Asin(sx / (Math.Sqrt((length + s1) * (length + s2)))));
       };
       cov.CrossCovariance = (x, xt, i, j) => {
-        int k = 0;
+        double sx = 1.0;
+        double s1 = 1.0;
+        double s2 = 1.0;
         foreach (var col in columnIndices) {
-          values[k] = x[i, col];
-          k++;
+          sx += x[i, col] * xt[j, col];
+          s1 += x[i, col] * x[i, col];
+          s2 += xt[j, col] * xt[j, col];
         }
-        foreach (var col in columnIndices) {
-          values[k] = xt[j, col];
-          k++;
-        }
-        values[k] = Math.Log(Math.Sqrt(length));
-        values[k + 1] = Math.Log(Math.Sqrt(scale));
-        return c.Evaluate(values);
+
+        return (scale * Math.Asin(sx / (Math.Sqrt((length + s1) * (length + s2)))));
       };
-      cov.CovarianceGradient = (x, i, j) => {
-        int k = 0;
-        foreach (var col in columnIndices) {
-          values[k] = x[i, col];
-          k++;
-        }
-        foreach (var col in columnIndices) {
-          values[k] = x[j, col];
-          k++;
-        }
-        values[k] = Math.Log(Math.Sqrt(length));
-        values[k + 1] = Math.Log(Math.Sqrt(scale));
-        return c.Differentiate(values).Item1.Skip(columnIndices.Count() * 2);
-      };
+      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, length, scale, columnIndices, fixedLength, fixedScale);
       return cov;
     }
 
+    // order of returned gradients must match the order in GetParameterValues!
+    private static IEnumerable<double> GetGradient(double[,] x, int i, int j, double length, double scale, IEnumerable<int> columnIndices,
+      bool fixedLength, bool fixedScale) {
+      {
+        double sx = 1.0;
+        double s1 = 1.0;
+        double s2 = 1.0;
+        foreach (var col in columnIndices) {
+          sx += x[i, col] * x[j, col];
+          s1 += x[i, col] * x[i, col];
+          s2 += x[j, col] * x[j, col];
+        }
+        var h = (length + s1) * (length + s2);
+        var f = sx / Math.Sqrt(h);
+        if (!fixedLength) {
+          yield return -scale / Math.Sqrt(1.0 - f * f) * ((length * sx * (2.0 * length + s1 + s2)) / Math.Pow(h, 3.0 / 2.0));
+        }
+        if (!fixedScale) {
+          yield return 2.0 * scale * Math.Asin(f);
+        }
+      }
+    }
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNoise.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNoise.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovarianceNoise.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -37,4 +37,7 @@
       get { return (IValueParameter<DoubleValue>)Parameters["Scale"]; }
     }
+    private bool HasFixedScaleParameter {
+      get { return ScaleParameter.Value != null; }
+    }
 
     [StorableConstructor]
@@ -60,5 +63,5 @@
 
     public int GetNumberOfParameters(int numberOfVariables) {
-      return ScaleParameter.Value != null ? 0 : 1;
+      return HasFixedScaleParameter ? 0 : 1;
     }
 
@@ -72,5 +75,5 @@
       int c = 0;
       // gather parameter values
-      if (ScaleParameter.Value != null) {
+      if (HasFixedScaleParameter) {
         scale = ScaleParameter.Value.Value;
       } else {
@@ -84,9 +87,13 @@
       double scale;
       GetParameterValues(p, out scale);
+      var fixedScale = HasFixedScaleParameter;
       // create functions
       var cov = new ParameterizedCovarianceFunction();
       cov.Covariance = (x, i, j) => i == j ? scale : 0.0;
-      cov.CrossCovariance = (x, xt, i, j) => 0.0;
-      cov.CovarianceGradient = (x, i, j) => Enumerable.Repeat(i == j ? 2.0 * scale : 0.0, 1);
+      cov.CrossCovariance = (x, xt, i, j) => Util.SqrDist(x, i, xt, j, 1.0, columnIndices) < 1e-9 ? scale : 0.0;
+      if (fixedScale)
+        cov.CovarianceGradient = (x, i, j) => Enumerable.Empty<double>();
+      else
+        cov.CovarianceGradient = (x, i, j) => Enumerable.Repeat(i == j ? 2.0 * scale : 0.0, 1);
       return cov;
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovariancePeriodic.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovariancePeriodic.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/GaussianProcess/CovarianceFunctions/CovariancePeriodic.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -46,4 +46,14 @@
     }
 
+    private bool HasFixedScaleParameter {
+      get { return ScaleParameter.Value != null; }
+    }
+    private bool HasFixedInverseLengthParameter {
+      get { return InverseLengthParameter.Value != null; }
+    }
+    private bool HasFixedPeriodParameter {
+      get { return PeriodParameter.Value != null; }
+    }
+
 
     [StorableConstructor]
@@ -68,7 +78,7 @@
 
     public int GetNumberOfParameters(int numberOfVariables) {
-      return (ScaleParameter.Value != null ? 0 : 1) +
-       (PeriodParameter.Value != null ? 0 : 1) +
-       (InverseLengthParameter.Value != null ? 0 : 1);
+      return (HasFixedScaleParameter ? 0 : 1) +
+       (HasFixedPeriodParameter ? 0 : 1) +
+       (HasFixedInverseLengthParameter ? 0 : 1);
     }
 
@@ -82,9 +92,9 @@
 
 
-    private void GetParameterValues(double[] 
+    private void GetParameterValues(double[]
       p, out double scale, out double period, out double inverseLength) {
       // gather parameter values
       int c = 0;
-      if (InverseLengthParameter.Value != null) {
+      if (HasFixedInverseLengthParameter) {
         inverseLength = InverseLengthParameter.Value.Value;
       } else {
@@ -92,5 +102,5 @@
         c++;
       }
-      if (PeriodParameter.Value != null) {
+      if (HasFixedPeriodParameter) {
         period = PeriodParameter.Value.Value;
       } else {
@@ -98,5 +108,5 @@
         c++;
       }
-      if (ScaleParameter.Value != null) {
+      if (HasFixedScaleParameter) {
         scale = ScaleParameter.Value.Value;
       } else {
@@ -110,4 +120,7 @@
       double inverseLength, period, scale;
       GetParameterValues(p, out scale, out period, out inverseLength);
+      var fixedInverseLength = HasFixedInverseLengthParameter;
+      var fixedPeriod = HasFixedPeriodParameter;
+      var fixedScale = HasFixedScaleParameter;
       // create functions
       var cov = new ParameterizedCovarianceFunction();
@@ -128,17 +141,21 @@
         return scale * Math.Exp(-2.0 * k);
       };
-      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, columnIndices, scale, period, inverseLength);
+      cov.CovarianceGradient = (x, i, j) => GetGradient(x, i, j, columnIndices, scale, period, inverseLength, fixedInverseLength, fixedPeriod, fixedScale);
       return cov;
     }
 
 
-    private static IEnumerable<double> GetGradient(double[,] x, int i, int j, IEnumerable<int> columnIndices, double scale, double period, double inverseLength) {
+    private static IEnumerable<double> GetGradient(double[,] x, int i, int j, IEnumerable<int> columnIndices, double scale, double period, double inverseLength,
+      bool fixedInverseLength, bool fixedPeriod, bool fixedScale) {
       double k = i == j ? 0.0 : Math.PI * GetDistance(x, x, i, j, columnIndices) / period;
       double gradient = Math.Sin(k) * inverseLength;
       gradient *= gradient;
-      yield return 4.0 * scale * Math.Exp(-2.0 * gradient) * gradient;
-      double r = Math.Sin(k) * inverseLength;
-      yield return 2.0 * k * scale * Math.Exp(-2 * r * r) *Math.Sin(2*k) * inverseLength * inverseLength;
-      yield return 2.0 * scale * Math.Exp(-2 * gradient); 
+      if (!fixedInverseLength) yield return 4.0 * scale * Math.Exp(-2.0 * gradient) * gradient;
+      if (!fixedPeriod) {
+        double r = Math.Sin(k) * inverseLength;
+        yield return 2.0 * k * scale * Math.Exp(-2 * r * r) * Math.Sin(2 * k) * inverseLength * inverseLength;
+      }
+      if (!fixedScale)
+        yield return 2.0 * scale * Math.Exp(-2 * gradient);
 
     }
